#include <Arduino.h>
#include "Button.h"

#define   BUTTON_INTERRUPT_PIN    2

static volatile bool fired = false;

void buttonIsr();
void buttonIsrDummy();


Button::Button()
{
}


Button::~Button()
{
}


void Button::init()
{
	//  Serial.println("Button::init");
	pinMode(BUTTON_INTERRUPT_PIN, INPUT);
	digitalRead(BUTTON_INTERRUPT_PIN);
	attachInterrupt(digitalPinToInterrupt(BUTTON_INTERRUPT_PIN), buttonIsr, FALLING);
}

void Button::setInterrupt()
{
	attachInterrupt(digitalPinToInterrupt(BUTTON_INTERRUPT_PIN), buttonIsr, FALLING);
}

void Button::setDummyInterrupt()
{
	attachInterrupt(digitalPinToInterrupt(BUTTON_INTERRUPT_PIN), buttonIsrDummy, FALLING);
}

Action  *Button::getAction()
{
	Action    *pAction = new Action();
	int       millisStart = 0;
	int       millisEnd = 0;

	pAction->setActionType(ACTIONTYPE::NONE);
	if (fired)
	{
		millisStart = millis();
		pAction->setActionType(ACTIONTYPE::PUSH_BUTTON_SHORT);
		int wert = digitalRead(BUTTON_INTERRUPT_PIN);

		while (wert == 0)
		{
			millisEnd = millis();
			if ((millisEnd - millisStart) > 2000)
				break;
			wert = digitalRead(BUTTON_INTERRUPT_PIN);
		}
		millisEnd = millis();
		if ((millisEnd - millisStart) > 1000)
			pAction->setActionType(ACTIONTYPE::PUSH_BUTTON_LONG);
		fired = false;
	}
	return pAction;
}


void buttonIsr()
{
	if (fired == false)
	{
		fired = true;
	}
}

void buttonIsrDummy()
{
}
