#include <Arduino.h>
#include "ChannelRelay.h"

#define     CHANNEL_RELAY_PIN_5   36
#define     CHANNEL_RELAY_PIN_4   34
#define     CHANNEL_RELAY_PIN_3   32
#define     CHANNEL_RELAY_PIN_2   30
#define     CHANNEL_RELAY_PIN_1   28

ChannelRelay::ChannelRelay()
{
}


ChannelRelay::~ChannelRelay()
{
}


void ChannelRelay::init()
{
	for (int i = 0; i < 5; i++)
	{
		pinMode(getRalayPin(i), OUTPUT);
	}
	deselectAllChannels();
}


void ChannelRelay::deselectAllChannels(void)
{
	for (int i = 0; i < 5; i++)
	{
		digitalWrite(getRalayPin(i), 0);
	}
	delay(3);       // ms - Sicher abschalten
}



void ChannelRelay::switchRelays(int newValue)
{
	digitalWrite(getRalayPin(newValue), 1);
	delay(3);       // ms - nicht notwendig
}

int ChannelRelay::getRalayPin(int value)
{
	switch (value)
	{
	case 0:
		return CHANNEL_RELAY_PIN_1;
		break;

	case 1:
		return CHANNEL_RELAY_PIN_2;
		break;

	case 2:
		return CHANNEL_RELAY_PIN_3;
		break;

	case 3:
		return CHANNEL_RELAY_PIN_4;
		break;

	case 4:
		return CHANNEL_RELAY_PIN_5;
		break;
	}
}
