#include <Arduino.h>
#include "Controls.h"



Controls::Controls()
{
	pRemoteControl = new RC5();
	pRotaryEncoder = new RotaryEncoder();
	pButton = new Button();

}


Controls::~Controls()
{
	if (pRemoteControl != nullptr)
		delete pRemoteControl;
	if (pRotaryEncoder != nullptr)
		delete pRotaryEncoder;
	if (pButton != nullptr)
		delete pButton;
}

void Controls::init(RC5_COMMAND_VALUES *rc5CommandsPar)
{
	pRemoteControl->init(rc5CommandsPar);
	pRotaryEncoder->init();
	pButton->init();
}

Action *Controls::getAction()
{
	Action          *pAction = pRemoteControl->getAction();

	if (pAction->getActionType() == NONE)
	{
		delete pAction;
		pAction = pButton->getAction();
		if (pAction->getActionType() == NONE)
		{
			delete pAction;
			pAction = pRotaryEncoder->getAction();
		}
	}
	else
	{
		int		rcCode = pAction->getRcCode();
		char	buffer[100];

//		sprintf(buffer, "Controls::getAction RC5 %d Toggle %d", rcCode, pAction->getToggleBit());
//		Serial.println(buffer);
	}
	return pAction;
}


RotaryEncoder *Controls::getRotaryEncoder()
{
	return pRotaryEncoder;
}

Button *Controls::getButton()
{
	return pButton;
}

RC5 *Controls::getRC5()
{
	return pRemoteControl;
}
