//#pragma once
#include <Arduino.h>
#include "InitValues.h"
#include "X9C103.h"
#include "DisplayOled.h"
#include "Controls.h"
#include "ChannelRelay.h"
#include "Port.h"

class DSPamPi
{
private:
	InitValues					*pInitValues;
	X9C103						*pX9C103;
	Port                        mutePort;
	Port                        standbyPort;
	bool                        isMute = false;
	bool                        isStandby = false;
	bool                        isDisplayOn = false;
	DisplayOled                 *pDisplay;
	Controls					*pControls;
	ChannelRelay                channelRelay;
	bool                        rcReceivedOn = false;
	int                         channel;
	String                      softwareVersion;
	int                         volume[10];
	long                        lastDisplayOffActivity = 0;
	unsigned long               lastVolumeSaveTime;
	int                         countSaveCommands = 0;

	bool checkParameterVersion(String parameterVersion, String compatibleParameterVersions[]);
	void displayVolumeSave(int volume);
	bool isVolumeSave(unsigned long lastVolumeSaveTimePar);
	void resetVolumeSave();

public:
	DSPamPi();
	~DSPamPi();

	void init(String softwareVersion, String compatibleParameterVersions[]);
	void work(void);
	int  channelAbsolut(int newValue);
	int  channelAbsolutInit(int channel);
	int  channelRelativ(int delta);
	void changeMute();
	void volumeFromDefault();
//	int  lautstaerkeAbsolut(int newValue, bool saveValue, int channel);
	int  lautstaerkeRelativ(int delta, int channel);
};

