/*
 Name:		DSPamPiProject.ino
 Created:	26.01.2018 12:46:36
 Author:	Richard

 14.05.2018			1.10		Erste Betaversion
 16.05.2018			1.11		Diverse Bugs behoben
 17.05.2018			1.12		Diverse Bugs behoben
 22.05.2018			1.13		Diverse Bugs behoben
 24.05.2018			1.14		Diverse Bugs behoben
 26.05.2018			1.15		Diverse Bugs behoben
 10.06.2018			1.16		Lautstärkeregelung beim Umschalten der Kan�le (relativ und absolut) jetzt identisch
								Zeitverhalten Fernbedienung Einzelschritt Wiederholung optimiert
 10.06.2018			1.17		Debugging wieder aktiviert
 16.06.2018			1.18		X9C103 Decrement und Increment Delay Werte von 2 auf 1 ms gesetzt
								Neuer Bug aus 1.15 berichtigt. Lautstärkebegrenzung auf 0 und MAX_VOLUME (Initvariable) funktioniert wieder
 18.06.2018			1.19		RC5 Codes werden wieder angezeigt
								Zeit beim Start bis Mute Relay geschaltet wird von 4 auf 5 Sekunden erhöht
								Mute Relay schaltet 500 ms nach den Quellenrelays
 24.06.2018			1.20		RC5 Codes werden wieder angezeigt auch wenn noch nicht zugeordnet
								Initsequence nach Standbye an Kaltstart angepasst (bei 1.19 vergessen) - gleicher Code sollte in eine Funktion ausgelagert werden!!
								Delay bei Kaltstart und nach Standbye wieder auf 4000 ms gesetzt
 30.06.2018			1.21		Mute wird beim Kaltstart und nach Standbye erst deaktiviert, wenn die Lautstärke geregelt ist
*/

#include "DSPamPi.h"
#include "InitValues.h"
#include "Config.h"

//#define   SETUP


#define   SOFTWARE_VERSION              "01.21"
#define   PARAMETER_VERSION             "01.10"
#define   START_CHANNEL                 0                       // 0 .. 4
#define   RC5_RC6                       0                       // RC5 ist 0, RC6 ist 1
#define	  MAX_VOLUME					80


String compatibleParameterVersions[] = {
	String("01.10")
};



int   anzahlRC5Commands = (sizeof(rc5Commands) / sizeof(rc5Commands[0]));

DSPamPi	*DSPamPI = nullptr;

// the setup function runs once when you press reset or power the board
void setup() {

	Serial.begin(9600);

#ifdef SETUP
	InitValues        InitValues(PARAMETER_VERSION,
		START_CHANNEL, RC5_RC6,
		LABEL_CHANNEL1, DEFAULT_VOLUME_CHANNEL1,
		DISPLAY_CHANNEL2, DEFAULT_VOLUME_CHANNEL2,
		DISPLAY_CHANNEL3, DEFAULT_VOLUME_CHANNEL3,
		DISPLAY_CHANNEL4, DEFAULT_VOLUME_CHANNEL4,
		DISPLAY_CHANNEL5, DEFAULT_VOLUME_CHANNEL5,
		MAX_VOLUME,
		rc5Commands);

#endif                          

	DSPamPI = new DSPamPi();

	DSPamPI->init((String)SOFTWARE_VERSION, compatibleParameterVersions);
}

// the loop function runs over and over again until power down or reset
void loop() {
	DSPamPI->work();
}
