#pragma once
#include <Arduino.h>
#include <Wstring.h>

#define   DISPLAY_UPPER_LINE  0
#define   DISPLAY_LOWER_LINE  1


class DisplayOled
{
protected:
	int volumeSave;
	bool isMuteSave;
	String channelSave;
	void InitOled();
	void WriteIns(unsigned char instruction);
	void SendNibble(unsigned char wert);
	void SendNibbleData(unsigned char wert);
	unsigned char ReadNibbleData();
	int getStartPosition(String displayString);
	void setCursor(int column, int row);
	byte utf8ascii(byte ascii);
	String utf8ascii(String s);
	bool rcFlashDisplay = false;

public:
	DisplayOled();
	~DisplayOled();
	void init(String softwareVersion);
	void displayStart(String softwareVersion);
	void error(char *zeile1, char *zeile2);
	void displayVolume(int volume, bool isMute);
	void clearVolume();
	void displayChannel(String pChannel);
	void displayString(int line, String value);
	virtual size_t write(uint8_t);
	void print(const char *);
	void rcFlash(bool on);
	void displayOff();
	void displayOn();
};
