#pragma once
#include <SPI.h>
#include "RC5.h"

class InitValues
{
public:
	String					*pParameterVersion;
	int                     channel;
	int                     rc5Rc6;             // RC5 ist 0, RC6 ist 1
	int                     volumeChannel1;
	int                     volumeChannel2;
	int                     volumeChannel3;
	int                     volumeChannel4;
	int                     volumeChannel5;
	String                  *pLabelChannel1;
	String                  *pLabelChannel2;
	String                  *pLabelChannel3;
	String                  *pLabelChannel4;
	String                  *pLabelChannel5;
	RC5_COMMAND_VALUES      *pRc5Commands;
	int						maxVolume;

	InitValues();
	InitValues(String parameterVersionPar, int channelPar, int rc5Rc6Par,
		String labelChannel1Par, int volumeChannel1Par,
		String labelChannel2Par, int volumeChannel2Par,
		String labelChannel3Par, int volumeChannel3Par,
		String labelChannel4Par, int volumeChannel4Par,
		String labelChannel5Par, int volumeChannel5Par,
		int maxVolumePar,
		RC5_COMMAND_VALUES *rc5CommandsPar);

	~InitValues();

	String *getChannelName(int channel);
	void saveNVRamChannel(int channel);
	void saveNVRamVolumeChannel(int channel, int volumeChannel);
	int getChannelDefaultValue(int channel);
	void writeLabel(int offsetLabel, String label);
	String *readLabel(int offset);
	void writeRc5Commands(int offsetCommands, RC5_COMMAND_VALUES *rc5CommandsPar);
	RC5_COMMAND_VALUES *readRc5Commands(int offset);
	String *getParameterVersion();
	int getMaxVolume();
};
