#pragma once
#include "RC.h"
#include  "Action.h"

enum RC5_COMMANDS { RC5_ZERO, RC5_ONE, RC5_TWO, RC5_THREE, RC5_FOUR, RC5_FIVE, RC5_SIX, RC5_SEVEN, RC5_EIGHT, RC5_NINE, RC5_VOLUME_PLUS, RC5_VOLUME_MINUS, 
		RC5_CHANNEL_PLUS, RC5_CHANNEL_MINUS, RC5_MUTE, RC5_POWER, RC5_SET, RC5_DISPLAY, RC5_VOLUME_RESTORE, RC5_END = 127 };

typedef struct
{
	RC5_COMMANDS    command;
	int             value;
} RC5_COMMAND_VALUES;

// Minimale Zeit fr Flankenwechsel
#define RC5_MIN_TIME 711

// Minimale Zeit fr langen Flankenwechsel
#define RC5_MAX_LONG_PULSE_TIME 1422

// Maximale Zeit fr Flankenwechsel
#define RC5_MAX_TIME 2222



class RC5 :
	public RC
{
private:
	RC5_COMMAND_VALUES * pRc5Commands;
public:
	RC5();
	~RC5();
//	void init(RC5_COMMAND_VALUES *rc5CommandsPar, bool *rcReceivedOn);
	void init(RC5_COMMAND_VALUES *rc5CommandsPar);
	Action *getAction();
	RC5_COMMANDS  getRc5Command(int rc5Value);
	ACTIONTYPE    getActionFromRc5(RC5_COMMANDS command);
	int           getAbsoluteChannelFromRc5(RC5_COMMANDS rc5Command);
	void          displayRcCodeReceived();
};
