#include <Arduino.h>
#include "RotaryEncoder.h"

#define   ENCODER_INTERRUPT_PIN       3
#define   ENCODER_NON_INTERRUPT_PIN   4

volatile bool fired = false;
volatile int volume = 0;

void volumeIsr();
void volumeIsrDummy();


RotaryEncoder::RotaryEncoder()
{
}


RotaryEncoder::~RotaryEncoder()
{
}



void RotaryEncoder::init()
{
	//  Serial.println("RotaryEncoder::init");  
	pinMode(ENCODER_INTERRUPT_PIN, INPUT);
	pinMode(ENCODER_NON_INTERRUPT_PIN, INPUT);
	attachInterrupt(digitalPinToInterrupt(ENCODER_INTERRUPT_PIN), volumeIsr, FALLING);
}


void RotaryEncoder::setInterrupt()
{
	attachInterrupt(digitalPinToInterrupt(ENCODER_INTERRUPT_PIN), volumeIsr, FALLING);
}

void RotaryEncoder::setDummyInterrupt()
{
	attachInterrupt(digitalPinToInterrupt(ENCODER_INTERRUPT_PIN), volumeIsrDummy, FALLING);
}

Action *RotaryEncoder::getAction()
{
	Action *pAction = new Action();

	pAction->setActionType(NONE);
	if (fired)
	{

		if (volume == 1)
			pAction->setActionType(ROTATE_RIGHT);
		else
			pAction->setActionType(ROTATE_LEFT);
		fired = false;
	}
	return pAction;
}

void volumeIsr()
{
	if (fired == false)
	{
		if (digitalRead(ENCODER_NON_INTERRUPT_PIN) == 1)
		{
			volume = 1;
		}
		else
		{
			volume = -1;
		}
		fired = true;
	}
}

void volumeIsrDummy()
{
}
