#include <Arduino.h>
#include "X9C103.h"

#define		UDPIN		12
#define		INCPIN		11
#define		CSPIN		10


X9C103::X9C103()
{
}


X9C103::~X9C103()
{
}


void X9C103::initVorStandbyeHigh()
{
	pinMode(UDPIN, OUTPUT);
	pinMode(INCPIN, OUTPUT);
	pinMode(CSPIN, OUTPUT);

	digitalWrite(CSPIN, 1);
	digitalWrite(UDPIN, 1);
	digitalWrite(INCPIN, 1);
	delay(1);
}

void X9C103::initNachStandbyeHigh(int level)
{
	delay(1);
	increment(level);
}

void X9C103::increment()
{
	digitalWrite(CSPIN, 0);
	digitalWrite(UDPIN, 1);
	delay(1);
	digitalWrite(INCPIN, 0);
	delay(1);
	digitalWrite(CSPIN, 1);
	delay(1);
	digitalWrite(INCPIN, 1);
}

void X9C103::decrement()
{
	digitalWrite(CSPIN, 0);
	digitalWrite(UDPIN, 0);
	delay(1);
	digitalWrite(INCPIN, 0);
	delay(1);
	digitalWrite(CSPIN, 1);
	delay(1);
	digitalWrite(INCPIN, 1);
}

void X9C103::increment(int count)
{
	digitalWrite(CSPIN, 0);
	digitalWrite(UDPIN, 1);
	delay(1);
	for (int i = 0; i < count; i++)
	{
		digitalWrite(INCPIN, 0);
		delay(1);
		digitalWrite(INCPIN, 1);
		delay(1);
	}
	delay(1);
	digitalWrite(CSPIN, 1);
	delay(1);
	digitalWrite(INCPIN, 1);
}

void X9C103::decrement(int count)
{
	digitalWrite(CSPIN, 0);
	digitalWrite(UDPIN, 0);
	delay(1);
	for (int i = 0; i < count; i++)
	{
		digitalWrite(INCPIN, 0);
		delay(1);
		digitalWrite(INCPIN, 1);
		delay(1);
	}
	delay(1);
	digitalWrite(CSPIN, 1);
	delay(1);
	digitalWrite(INCPIN, 1);

}


void X9C103::save(void)
{
	digitalWrite(INCPIN, 1);
	delay(1);
	digitalWrite(CSPIN, 1);
}

void X9C103::clear(void)
{
	decrement(100);
	save();
}


void X9C103::set(int count)
{
	decrement(100);
	increment(count);
}


void X9C103::set(int count, int old)
{
	if (count != old)
	{
		if (count < old)
		{
			int decrementCount = old - count;

			decrement(decrementCount);
		}
		else
		{
			int incrementCount = count - old;

			increment(incrementCount);
		}
	}
}

